<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task35.10 user list</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class = "container">
        <div class = "text-center text-uppercase">
            <h2>Danh sách người dùng</h2>
        </div>
        <div class = "bootstrap d-flex justify-content-center">
            <div class = "row form-group">
                <div class = "col-sm-2">
                    <label>Name</label>
                </div>
                <div class = "col-sm-6">
                    <input id="input-name" placeholder="Input name to filter...">
                </div>
                <div class = "col-sm-4">
                    <button id="btn-filter" class = "btn-sm btn-success">Lọc Users</button>
                </div>
                
            </div>
        </div>
        <table class = "table table-border table-striped table-hover" id="table-users">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Name</th>
                    <th>Username</th>
                    <th>Email</th>
                    <th>Address</th>
                    <th>Zip code</th>
                    <th>Phone</th>
                    <th>Company</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody id="table-body">

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện cho nút chi tiết
        $("#table-users").on("click",".btn-detail",onBtnDetailClick);
        //gán sự kiện cho nút lọc users
        $("#btn-filter").click(function(){
            onBtnFilterClick();
        });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        callApiGetDataUser();       
    };
    function onBtnDetailClick(paramButton){
      console.log("Nút chi tiết được ấn, id của user tương ứng là: " + $(this).data("id"));
      const vDETAIL_FORM_URL = "userDetail.html";
      var vUrlToOpenPage = vDETAIL_FORM_URL + "?" + "id=" + $(this).data("id");
      window.location.href = vUrlToOpenPage;
    }
    
    //hàm xử lý sự kiện click nút lọc user
    function onBtnFilterClick(){
        //b1: đọc dữ liệu
        var vInputName = $("#input-name").val();
        //b2: kiểm tra dữ liệu
        var vCheckFilter = validateInputName(vInputName);
        if (vCheckFilter){
            callApiGetDataUserForFilter();
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load data user
    function callApiGetDataUser(){
        "use strict";
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/",
            type: "GET",
            dataType: "json",
            success: function (paramRes){
                console.log(paramRes);
                loadDataToUserTable(paramRes);
            },
            error: function (ajaxContext){
                console.log(ajaxContext.responseText)
            }
        });
    }
    //hàm load data user
    function callApiGetDataUserForFilter(){
        "use strict";
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/",
            type: "GET",
            dataType: "json",
            success: function (paramRes){
                filterDataByName(paramRes);
            },
            error: function (ajaxContext){
                console.log(ajaxContext.responseText)
            }
        });
    }
    //hàm load dữ liệu vào user data table
    function loadDataToUserTable(paramUsers){
      var vUserTable = $("#table-users");
      $("#table-body").html("");//xóa bảng
      for (var bI =0; bI <paramUsers.length; bI++){
        //thêm dòng mới và gắn vào table
        var bNewRow = $("<tr>").appendTo(vUserTable);
        //thêm các ô, gắn vào dòng trên và điền dữ liệu innerHTML cho từng ô
        $("<td>", {html: paramUsers[bI].id}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].name}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].username}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].email}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].address.street + ", " 
            + paramUsers[bI].address.suite + ", "
            + paramUsers[bI].address.city}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].address.zipcode}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].phone}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].company.name}).appendTo(bNewRow);
        //ô action
        var bActionCell = $("<td>").appendTo(bNewRow);
        //tạo nút chi tiết
        var bDetailtButton = $("<button>", {
          html: "Chi tiết",
          class: "btn btn-success btn-detail"
        }).data("id", paramUsers[bI].id)
        .appendTo(bActionCell); //thêm vào ô action
        
      }
    }
    //hàm kiểm tra input name để lọc user:
    function validateInputName(paramInputName){
        if (paramInputName == ""){
            alert ("Please input name for filter!");
            return false;
        }
        else return true;
    }
    //hàm hiển thị kết quả filter
    function filterDataByName(paramUsers){
       var vFilterResult = paramUsers.filter(checkName,1);
       console.log(vFilterResult); 
       if (vFilterResult.length == 0){
        console.log("Không tồn tại user!");
       }      
    }
    //hàm kiểm tra tên
    function checkName(paramUsers){
        var vInputName = $("#input-name").val();
        if (paramUsers.name == vInputName){
            console.log("Tìm thấy user!");
            return paramUsers;
        }        
    }
</script>
</html>